<nav class="navbar header-container shadow">
	<a class="navbar-brand header-logo-link" href="{{path("app")}}">
		<img class="header-logo-img" alt="logo Netflax" src="{{ asset('img/netflax.png') }}">
	</a>

	<form method="post" action="/search" class="form-inline">
        <input class="form-control mr-sm-2 header-search-input" type="text" value="" name="searchFieldTitle" id="inputSearchTitle" placeholder="Rechercher un film ..." required autofocus>
		<button class="btn btn-outline-success my-2 my-sm-0 header-search-outline-btn" for="inputSearchTitle" type="submit">
            Rechercher
        </button>
        <span class="btn btn-outline-success my-2 my-sm-0 ml-2 header-search-btn" id="displayMore">
            Plus de filtres
    </span>
    </form>
	<ul class="header-nav-container">
		<li>
			<a class="header-nav-link" href="{{ path('app_userMovies') }}"
				data-toggle="tooltip" 
				data-original-title="Mes Favoris">
				<i class="fa fa-film fa-2x header-nav-icon"></i>
			</a>
		</li>
		<li>
			<a class="header-nav-link" href="{{ path('app_userDetails') }}"
				data-toggle="tooltip" 
				data-original-title="Mon profil">
				<i class="fa fa-user fa-2x header-nav-icon"></i>
			</a>
		</li>
		<li>
			<a class="header-nav-link" href="{{ path('app_logout') }}"
				data-toggle="tooltip" 
				data-original-title="Déconnexion">
				<i class="fa fa-power-off fa-2x header-nav-icon"></i>
			</a>
		</li>  
	</ul>
</nav>
<form method="post" action="/discoverByFilter" class="form-inline filters">
    <div class="hidden-filter" id="hiddenFilters">
        <input class="form-control mr-sm-2 header-search-input" type="text" value="" id="inputSearchGenre" placeholder="Rechercher un genre ..." autofocus>
        <input class="form-control mr-sm-2 header-search-input" type="text" value="" id="inputSearchPeople" placeholder="Rechercher un acteur ..." autofocus>
        <input type="hidden" value="" name="searchFieldGenre" id="inputSearchGenreHidden" >
        <input type="hidden" value="" name="searchFieldPeople" id="inputSearchPeopleHidden">
        <button class="btn btn-outline-success my-2 my-sm-0 header-search-outline-btn" type="submit" id="searchFilter">
            Rechercher
        </button>
    </div>
    <span class="btn btn-outline-warning my-2 my-sm-0 ml-2 header-search-btn" id="displayLess">
        Moins de filtres
    </span>
</form>


{% block javascripts %}
    <script>
        $(document).ready(function() {
            $('[data-toggle="tooltip"]').tooltip();

            $('#displayMore').click(() => {
                $('form.filters').css('display', 'flex').toggleClass('open');
                $('#displayMore').hide();
            });

            $('#displayLess').click(() => {
                $('form.filters').hide().toggleClass('open');
                $('#displayMore').show();
            });

            $('#searchFilter').click(() => {
                addToHiddenGenre();
            });

			$('#inputSearchTitle').autocomplete({
                minLength:2,
                delay:200,
                scrollHeight:100,
                source: async function(e,t){
                    term = e.term;
                    let customUrl = '{{ path('search_movie', {'title': 'SEARCH'}) }}';
                    customUrl = customUrl.replace('SEARCH', term);
                    let result = await $.ajax({
                        url: customUrl,
                        type: 'GET',
                        success: function (response) {
                            return response;
                        }
                    });
					t(result.movies);
                },
            });

            function addToHiddenPeople(ui) {
                var self = $('#inputSearchPeopleHidden')[0];
                self.value = ui.item.id;
            }

            function addToHiddenGenre() {
                var self = $('#inputSearchGenreHidden')[0];
                var genres = split($('#inputSearchGenre')[0].value);
                var genresList = listGenres.responseJSON.genres;
                var value= [];
                genres.forEach(genre => {
                    if(genre != null && genre != "") {
                        var type = genresList.find(item => item.name === genre);
                        value.push(type.id.toString());
                    }
                })
                self.value = value.join( "|" );
            }

            $('#inputSearchPeople').autocomplete({
                minLength:2,
                delay:200,
                scrollHeight:100,
                source: async function(e,t){
                    term = e.term;
                    let customUrl = '{{ path('search_people', {'people': 'SEARCH'}) }}';
                    customUrl = customUrl.replace('SEARCH', term);
                    let result = await $.ajax({
                        url: customUrl,
                        type: 'GET',
                        success: function (response) {
                            return response;
                        }
                    }); 
					t(result.peoples);
                },
                focus: function() {
                    return false;
                },
                select: function( event, ui ) {
                    this.value = ui.item.name;
                    addToHiddenPeople(ui);
                    return false;
                }
            }).data( "ui-autocomplete" )._renderItem = function( ul, item ) {
               return $( "<li>" )
               .append(  "<a>" + item.name + "</a>"  )
               .appendTo( ul );
            };;

            var listGenres = $
                .ajax({
                    url: '{{ path('search_genre')}}',
                    type: 'GET',
                    success: function (response) {
                        return response;
                    }
                });

            function split( val ) {
                return val.split( /,\s*/ );
            }
            function extractLast( term ) {
                return split( term ).pop();
            }
            $('#inputSearchGenre')
            // don't navigate away from the field on tab when selecting an item
            .on( "focus", function( event ) {
                if ( event.keyCode === $.ui.keyCode.TAB &&
                    $( this ).autocomplete( "instance" ).menu.active ) {
                event.preventDefault();
                }
            }).autocomplete({
                minLength:0,
                delay:200,
                scrollHeight:100,
                source: function( request, response ) {
                    response(listGenres.responseJSON.genres);
                },
                focus: function( event, ui ) {
                    $(this).autocomplete("search");
                },
                select: function( event, ui ) {
                    var terms = split( this.value );
                    // remove the current input
                    terms.pop();
                    // add the selected item
                    terms.push( ui.item.name );
                    // add placeholder to get the comma-and-space at the end
                    terms.push( "" );
                    this.value = terms.join( ", " );
                    return false;
                }
            }).data( "ui-autocomplete" )._renderItem = function( ul, item ) {
               return $( "<li>" )
               .append(  "<a>" + item.name + "</a>"  )
               .appendTo( ul );
            }
        });
    </script>
{% endblock %}